import java.awt.image.*;
import java.awt.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.universe.*;
import java.util.*;
import java.awt.event.*;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.behaviors.vp.*;
import com.sun.j3d.utils.image.*;
public class Engine extends Canvas3D{
    Group start;
    Group end;
    int w;
    int h;
    boolean keypressed=false;
    int keycode=0;
    Group direct;
    String status="";
    TransformGroup world2;
    BranchGroup world;
    BranchGroup temp;
    AWTBehavior behavior;
    AmbientLight ambientlight;
    SimpleUniverse simplu;
    Node disp;
    View view;
    Transform3D trans;
    ViewPlatform vp;
    ViewPlatformBehavior vpb;
    TransformGroup vpcontainer;
    public Engine(){
        super(SimpleUniverse.getPreferredConfiguration());
        direct=new Group();
        world2=new TransformGroup();
        ambientlight=new AmbientLight();
        world=new BranchGroup();
        world.setCapability(BranchGroup.ALLOW_CHILDREN_READ);
        world.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
        world.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
        world.setCapability(BranchGroup.ALLOW_DETACH);
        world.addChild(world2);
        world.addChild(ambientlight);
        behavior=new AWTBehavior(this);
        disp=world.cloneTree();
        temp=new BranchGroup();
        temp.addChild(disp);
        simplu=new SimpleUniverse(this);
        view=getView();
        view.setBackClipDistance(33000.0f);
        view.setFieldOfView(50.0f/180.0f*Math.PI);
        vp=new ViewPlatform();
        view.attachViewPlatform(vp);
        vpcontainer=new TransformGroup();
        vpcontainer.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        vpcontainer.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        vpcontainer.addChild(vp);
        BranchGroup bg=new BranchGroup();
        bg.addChild(vpcontainer);
        bg.addChild(behavior);
        simplu.addBranchGraph(bg);
        simplu.addBranchGraph(world);
    }
    public void repaint2(){
        simplu=new SimpleUniverse(this);
        disp=world.cloneTree();
        temp=new BranchGroup();
        temp.addChild(disp);
        view=getView();
        view.setBackClipDistance(33000.0f);
        view.setFieldOfView(50.0f/180.0f*Math.PI);
        simplu.addBranchGraph(temp);
    }
    public void setCam(Vektor campos,float wx,float wy){
	float z=(float)Math.cos(wy);
	float w=(float)Math.sin(wy);
	float y=(float)Math.sin(wx)*w;
	float x=(float)Math.cos(wx)*w;
        double wy2=wy+Math.PI/2;
        double wx2=wx;
	float z2=(float)Math.cos(wy2);
	float w2=(float)Math.sin(wy2);
	float y2=(float)Math.sin(wx2)*w2;
	float x2=(float)Math.cos(wx2)*w2;
        trans=new Transform3D();
        trans.lookAt(new Point3d(campos.x,campos.y,campos.z),new Point3d(campos.x+x,campos.y+y,campos.z+z),new Vector3d(x2,y2,z2));
        trans.invert();
        vpcontainer.setTransform(trans);
    }
    public void paintb(Graphics g){
        if(world==null){
            return;
        }
        if(!"".equals(status)){
            g.setColor(Color.black);
            g.fillRect(0,0,w,15);
            g.setColor(Color.white);
            g.drawLine(0,15,w,15);
            g.drawString(status,10,0);
        }
    }
    public void setStatus(String status){
        this.status=status;
    }
    public int getKeyCode(){
        int key=keycode;
        keycode=0;
        return key;
    }
    public void add(Polygon pol){
        if(pol.mesh!=null){
            world.addChild(pol.bg);
            direct.add(pol);
        }
    }
    public void add(Kugel kugel){
        if(kugel.mesh!=null){
            world.addChild(kugel.bg);
            direct.add(kugel);
        }
    }
    public void remove(Polygon pol){
        direct.remove(pol);
        if(pol.mesh!=null){
            world.removeChild(pol.bg);
        }
    }
    public void remove(Kugel kugel){
        direct.remove(kugel);
        if(kugel.mesh!=null){
            world.removeChild(kugel.bg);
        }
    }
    public void add(Group g){
        if(start==null){
            start=g;
            end=g;
        }
        else{
            end.next=g;
            end=end.next;
        }
        Polygon cur=g.start;
        while(cur!=null){
            if(cur.mesh!=null){
//System.out.println(cur.bg);
                world.addChild(cur.bg);
            }
            cur=cur.next;
        }
//System.out.println("zwisch");
        Kugel curb=g.startb;
        while(curb!=null){
            if(curb.mesh!=null){
                world.addChild(curb.bg);
            }
            curb=curb.next;
        }
    }
    public void remove(Group g){
        Group cur=start;
        Group fore=null;
        while(cur!=null){
            boolean b=true;
            if(cur==g){
                if(fore==null){
                    if(end==start){
                        end=null;
                        start=null;
                    }
                    else{
                        start=start.next;
                    }
                }
                else{
                    fore.next=cur.next;
                    b=false;
                }
            }
            if(b){
                fore=cur;
                cur=cur.next;
            }
            else{
                cur=cur.next;
            }
        }
        Polygon curb=g.start;
        while(curb!=null){
            if(curb.mesh!=null){
                world.removeChild(curb.bg);
            }
            curb=curb.next;
        }
        Kugel curb2=g.startb;
        while(curb2!=null){
            if(curb2.mesh!=null){
                world.removeChild(curb2.bg);
            }
            curb2=curb2.next;
        }
    }
    public void transform(float x,float y,float z){
        Group cur=start;
        while(cur!=null){
            cur.transform(x,y,z);
            cur=cur.next;
        }
        direct.transform(x,y,z);
    }
    public void rotLeft(float w){
        Group cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
        direct.rotLeft(w);
    }
    public void rotUp(float w){
        Group cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
        direct.rotUp(w);
    }
}
class Group{
    Polygon start;
    Polygon end;
    Kugel startb;
    Kugel endb;
    Group next;
    public Group(){
    }
    public void add(Polygon pol){
        if(start==null){
            start=pol;
            end=pol;
        }
        else{
            end.next=pol;
            end=end.next;
        }
    }
    public void remove(Polygon pol){
        Polygon cur=start;
        Polygon fore=null;
        while(cur!=null){
            boolean b=true;
            if(cur==pol){
                if(fore==null){
                    if(end==start){
                        end=null;
                        start=null;
                    }
                    else{
                        start=start.next;
                    }
                }
                else{
                    fore.next=cur.next;
                    b=false;
                }
            }
            if(b){
                fore=cur;
                cur=cur.next;
            }
            else{
                cur=cur.next;
            }
        }
    }
    public void add(Kugel kugel){
        if(startb==null){
            startb=kugel;
            endb=kugel;
        }
        else{
            endb.next=kugel;
            endb=endb.next;
        }
    }
    public void remove(Kugel kugel){
        Kugel curb=startb;
        Kugel fore=null;
        while(curb!=null){
            boolean b=true;
            if(curb==kugel){
                if(fore==null){
                    if(endb==startb){
                        endb=null;
                        startb=null;
                    }
                    else{
                        startb=startb.next;
                    }
                }
                else{
                    fore.next=curb.next;
                    b=false;
                }
            }
            if(b){
                fore=curb;
                curb=curb.next;
            }
            else{
                curb=curb.next;
            }
        }
    }
    public void transform(float x,float y,float z){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(x,y,z);
            cur=cur.next;
        }
        Kugel curb=startb;
        while(curb!=null){
            curb.transform(x,y,z);
            curb=curb.next;
        }
    }
    public void rotLeft(float w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
        Kugel curb=startb;
        while(curb!=null){
            curb.rotLeft(w);
            curb=curb.next;
        }
    }
    public void rotUp(float w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
        Kugel curb=startb;
        while(curb!=null){
            curb.rotUp(w);
            curb=curb.next;
        }
    }
}
class Polygon{
    Polygon next;
    Vektor v1;
    Vektor v2;
    Vektor v3;
    Vektor v4;
    TransformGroup mesh;
    BufferedImage img;
    Transform3D transform;
    TriangleArray meshb;
    Shape3D meshc;
    boolean triangle=false;
    float[]pos;
    float[]texval;
    Texture2D tex;
    BranchGroup bg;
    public Polygon(Vektor v1,Vektor v2,Vektor v3,Vektor v4,Image img){
        this.v1=v1;
        this.v2=v2;
        this.v3=v3;
        this.v4=v4;
        Frame f=new Frame();
        int w=img.getWidth(f);
        int h=img.getHeight(f);
        while(w==-1||h==-1){
            try{
                w=img.getWidth(f);
                h=img.getHeight(f);
                Thread.yield();
            }
            catch(Exception e){
            }
        }
        TextureLoader tl=new TextureLoader(img,f);
        int bw=1;
        while(bw<w){
            bw=bw*2;
        }
        int bh=1;
        while(bh<h){
            bh=bh*2;
        }
        ImageComponent2D image = tl.getScaledImage(bw,bh);
        tex=new Texture2D();
        int form=tex.getFormat();
        int base=tex.getMipMapMode();
        tex = new Texture2D(base,form,bw,bh);
        tex.setImage(0,image);
        buildq();
    }
    public Polygon(Vektor v1,Vektor v2,Vektor v3,Image img){
        triangle=true;
        this.v1=v1;
        this.v2=v2;
        this.v3=v3;
        Frame f=new Frame();
        int w=img.getWidth(f);
        int h=img.getHeight(f);
        while(w==-1||h==-1){
            try{
                w=img.getWidth(f);
                h=img.getHeight(f);
                Thread.yield();
            }
            catch(Exception e){
            }
        }
        TextureLoader tl=new TextureLoader(img,f);
        int bw=1;
        while(bw<w){
            bw=bw*2;
        }
        int bh=1;
        while(bh<h){
            bh=bh*2;
        }
        ImageComponent2D image = tl.getScaledImage(bw,bh);
        tex=new Texture2D();
        int form=tex.getFormat();
        int base=tex.getMipMapMode();
        tex = new Texture2D(base,form,bw,bh);
        tex.setImage(0,image);
        buildt();
    }
    public void buildt(){
        try{
            pos=new float[9];
            pos[0]=v1.x;
            pos[1]=v1.y;
            pos[2]=v1.z;
            pos[3]=v2.x;
            pos[4]=v2.y;
            pos[5]=v2.z;
            pos[6]=v3.x;
            pos[7]=v3.y;
            pos[8]=v3.z;
            texval=new float[6];
            texval[0]=0.0f;
            texval[1]=0.0f;
            texval[2]=1.0f;
            texval[3]=0.0f;
            texval[4]=0.0f;
            texval[5]=1.0f;
            meshb=new TriangleArray(3,GeometryArray.COORDINATES|GeometryArray.TEXTURE_COORDINATE_2);
            meshb.setCoordinates(0,pos,0,3);
            meshb.setTextureCoordinates(0,texval,0,3);
            meshc=new Shape3D(meshb);
            Appearance app=new Appearance();
            PolygonAttributes pa=new PolygonAttributes();
            pa.setCullFace(PolygonAttributes.CULL_NONE);
            app.setPolygonAttributes(pa);
            mesh=new TransformGroup();
            mesh.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
            mesh.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
            app.setTexture(tex);
            meshc.setAppearance(app);
            mesh.addChild(meshc);
            transform=new Transform3D();
            mesh.setTransform(transform);
            bg=new BranchGroup();
            bg.addChild(mesh);
        }
        catch(Exception e){
        }
    }
    public void buildq(){
        try{
            pos=new float[18];
            pos[0]=v1.x;
            pos[1]=v1.y;
            pos[2]=v1.z;
            pos[3]=v2.x;
            pos[4]=v2.y;
            pos[5]=v2.z;
            pos[6]=v4.x;
            pos[7]=v4.y;
            pos[8]=v4.z;
            pos[9]=v2.x;
            pos[10]=v2.y;
            pos[11]=v2.z;
            pos[12]=v3.x;
            pos[13]=v3.y;
            pos[14]=v3.z;
            pos[15]=v4.x;
            pos[16]=v4.y;
            pos[17]=v4.z;
            texval=new float[12];
            texval[0]=0.0f;
            texval[1]=0.0f;
            texval[2]=1.0f;
            texval[3]=0.0f;
            texval[4]=0.0f;
            texval[5]=1.0f;
            texval[6]=1.0f;
            texval[7]=0.0f;
            texval[8]=1.0f;
            texval[9]=1.0f;
            texval[10]=0.0f;
            texval[11]=1.0f;
            meshb=new TriangleArray(6,GeometryArray.COORDINATES|GeometryArray.TEXTURE_COORDINATE_2);
            meshb.setCoordinates(0,pos,0,6);
            meshb.setTextureCoordinates(0,texval,0,6);
            meshc=new Shape3D(meshb);
            Appearance app=new Appearance();
            PolygonAttributes pa=new PolygonAttributes();
            pa.setCullFace(PolygonAttributes.CULL_NONE);
            app.setPolygonAttributes(pa);
            mesh=new TransformGroup();
            mesh.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
            mesh.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
            app.setTexture(tex);
            meshc.setAppearance(app);
            mesh.addChild(meshc);
            transform=new Transform3D();
            mesh.setTransform(transform);
            bg=new BranchGroup();
            bg.addChild(mesh);
        }
        catch(Exception e){
        }
    }
    public void transform(float x,float y,float z){
        Transform3D tf=new Transform3D();
        tf.setTranslation(new Vector3f(x,y,z));
        MatMult.multleft(transform,tf);
        mesh.setTransform(transform);
    }
    public void rotLeft(float w){
        float w2=(float)(w*180/Math.PI);
        Transform3D tf=new Transform3D();
        tf.setRotation(new AxisAngle4f(0.0f,1.0f,0.0f,w2));
        MatMult.multleft(transform,tf);
        mesh.setTransform(transform);
    }
    public void rotUp(float w){
        float w2=(float)(w*180/Math.PI);
        Transform3D tf=new Transform3D();
        tf.setRotation(new AxisAngle4f(1.0f,0.0f,0.0f,w2));
        MatMult.multleft(transform,tf);
        mesh.setTransform(transform);
    }
}
class Kugel{
    Kugel next;
    float[]pos=new float[3*3*2*256];
    Transform3D transform;
    TriangleArray meshb;
    Shape3D meshc;
    TransformGroup mesh;
    short radius;
    double[]posf=new double[3*3*2*256];
    BranchGroup bg;
    public Kugel(Vektor middle,int radiusb,int r,int g,int b){
        radius=(short)radiusb;
        for(int i=0;i<16;i++){
            for(int j=0;j<16;j++){
                double wx=((double)i/16.0)*Math.PI*2;
                double wy=((double)j/16.0)*Math.PI-Math.PI/2;
                double wxp=((double)(i+1)/16.0)*Math.PI*2;
                double wyp=((double)(j+1)/16.0)*Math.PI-Math.PI/2;
                double zu=Math.sin(wyp)*radius;
                double zd=Math.sin(wy)*radius;
                double hu=Math.cos(wyp)*radius;
                if(hu<0){
                    hu=-hu;
                }
                double hd=Math.cos(wy)*radius;
                if(hd<0){
                    hd=-hd;
                }
                double xuu=Math.cos(wxp)*hu;
                double yuu=Math.sin(wxp)*hu;
                double xdd=Math.cos(wx)*hd;
                double ydd=Math.sin(wx)*hd;
                double xud=Math.cos(wx)*hu;
                double yud=Math.sin(wx)*hu;
                double zud=zu;
                double xdu=Math.cos(wxp)*hd;
                double ydu=Math.sin(wxp)*hd;
                double zdu=zd;
                posf[(i*16+j)*18]=xdd;
                posf[(i*16+j)*18+1]=ydd;
                posf[(i*16+j)*18+2]=zd;
                posf[(i*16+j)*18+3]=xuu;
                posf[(i*16+j)*18+4]=yuu;
                posf[(i*16+j)*18+5]=zu;
                posf[(i*16+j)*18+6]=xud;
                posf[(i*16+j)*18+7]=yud;
                posf[(i*16+j)*18+8]=zud;

                posf[(i*16+j)*18+9]=xdd;
                posf[(i*16+j)*18+10]=ydd;
                posf[(i*16+j)*18+11]=zd;
                posf[(i*16+j)*18+12]=xuu;
                posf[(i*16+j)*18+13]=yuu;
                posf[(i*16+j)*18+14]=zu;
                posf[(i*16+j)*18+15]=xdu;
                posf[(i*16+j)*18+16]=ydu;
                posf[(i*16+j)*18+17]=zdu;
            }
        }
        for(int i=0;i<3*3*2*16*16;i++){
            pos[i]=(float)posf[i];
        }
        meshb=new TriangleArray(3*2*16*16,GeometryArray.COORDINATES|GeometryArray.COLOR_3);
        meshb.setCoordinates(0,pos,0,3*2*16*16);
        byte[]colbyte=new byte[3*3*2*16*16];
        for(int i=0;i<3*2*16*16;i++){
            colbyte[i*3]=(byte)r;
            colbyte[i*3+1]=(byte)g;
            colbyte[i*3+2]=(byte)b;
        }
        meshb.setColors(0,colbyte);
        meshc=new Shape3D(meshb);
        Appearance app=new Appearance();
        PolygonAttributes pa=new PolygonAttributes();
        pa.setCullFace(PolygonAttributes.CULL_NONE);
        app.setPolygonAttributes(pa);
        meshc.setAppearance(app);
        transform=new Transform3D();
        transform.setTranslation(new Vector3f(middle.x,middle.y,middle.z));
        mesh=new TransformGroup();
        mesh.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        mesh.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        mesh.addChild(meshc);
        mesh.setTransform(transform);
        bg=new BranchGroup();
        bg.addChild(mesh);
    }
    public void transform(float x,float y,float z){
        Transform3D tf=new Transform3D();
        tf.setTranslation(new Vector3f(x,y,z));
        MatMult.multleft(transform,tf);
        mesh.setTransform(transform);
    }
    public void rotLeft(float w){
        float w2=(float)(w*180/Math.PI);
        Transform3D tf=new Transform3D();
        tf.setRotation(new AxisAngle4f(0.0f,1.0f,0.0f,w2));
        MatMult.multleft(transform,tf);
        mesh.setTransform(transform);
    }
    public void rotUp(float w){
        float w2=(float)(w*180/Math.PI);
        Transform3D tf=new Transform3D();
        tf.setRotation(new AxisAngle4f(1.0f,0.0f,0.0f,w2));
        MatMult.multleft(transform,tf);
        mesh.setTransform(transform);
    }
}
class MatMult{
    public static void multleft(Transform3D original,Transform3D mult){
        float[]a=new float[16];
        mult.get(a);
        float[][]a2=new float[4][4];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                a2[i][j]=a[i*4+j];
            }
        }
        float[]b=new float[16];
        original.get(b);
        float[][]b2=new float[4][4];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                b2[i][j]=b[i*4+j];
            }
        }
        float[][]c2=new float[4][4];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                for(int k=0;k<4;k++){
                    c2[i][j]=c2[i][j]+a2[i][k]*b2[k][j];
                }
            }
        }
        float[]c=new float[16];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                c[i*4+j]=c2[i][j];
            }
        }
        original.set(c);
    }
}
class Vektor{
    short x;
    short y;
    short z;
    public Vektor(int x,int y,int z){
        this.x=(short)x;
        this.y=(short)y;
        this.z=(short)z;
    }
}
class SimpleBehavior extends Behavior{
    Engine eng;
    TransformGroup target;
    int keycode=0;
    public SimpleBehavior(Engine eng){
        this.eng=eng;
    }
    public int getKeyCode(){
        return keycode;
    }
    public void initialize(){
        setSchedulingBounds(new BoundingSphere(new Point3d(0,0,0),100));
        wakeupOn(new WakeupOnAWTEvent(AWTEvent.KEY_EVENT_MASK));
    }
    public void processStimulus(Enumeration enumeration){
        wakeupOn(new WakeupOnAWTEvent(AWTEvent.KEY_EVENT_MASK));
        KeyEvent event = (KeyEvent) ((WakeupOnAWTEvent) enumeration.nextElement()).getAWTEvent()[0];
        int key=event.getKeyCode();
        eng.keycode=key;
    }
    public Node cloneNode(boolean forceDuplicate){
        return (new SimpleBehavior(eng));
    }
}
class Projection{
    public static float[] convert(float[][]pro){
        float[]ret=new float[16];
        ret[0]=pro[0][0];
        ret[1]=pro[0][1];
        ret[2]=pro[0][2];
        ret[3]=pro[0][3];
        ret[4]=pro[1][0];
        ret[5]=pro[1][1];
        ret[6]=pro[1][2];
        ret[7]=pro[1][3];
        ret[8]=pro[2][0];
        ret[9]=pro[2][1];
        ret[10]=pro[2][2];
        ret[11]=pro[2][3];
        ret[12]=pro[3][0];
        ret[13]=pro[3][1];
        ret[14]=pro[3][2];
        ret[15]=pro[3][3];
        return ret;
    }
    public static float[] normalize(float[]v){
        float[]ret=new float[3];
        float len=(float)Math.sqrt(v[0]*v[0]+v[1]*v[1]+v[2]*v[2]);
        ret[0]=v[0]/len;
        ret[1]=v[1]/len;
        ret[2]=v[2]/len;
        return ret;
    }
    public static float[] vectorproduct(float[]a,float[]b){
        float[]ret=new float[3];
        ret[0]=a[1]*b[2]-a[2]*b[1];
        ret[1]=a[2]*b[0]-a[0]*b[2];
        ret[2]=a[0]*b[1]-a[1]*b[0];
        return ret;
    }
    public static float[][] projection(float eyex,float eyey,float eyez,float centerx,float centery,float centerz,float upx,float upy,float upz){
        float[]f=new float[3];
        f[0]=centerx-eyex;
        f[1]=centery-eyey;
        f[2]=centerz-eyez;
        float[]f2=normalize(f);
        float[]up=new float[3];
        up[0]=upx;
        up[1]=upy;
        up[2]=upz;
        float[]up2=normalize(up);
        float[]s=vectorproduct(f2,up2);
        float[]u=vectorproduct(s,f2);
        float[][]ret=new float[4][4];
        ret[0][0]=s[0];
        ret[0][1]=s[1];
        ret[0][2]=s[2];
        ret[0][3]=0;
        ret[1][0]=u[0];
        ret[1][1]=u[1];
        ret[1][2]=u[2];
        ret[1][3]=0;
        ret[2][0]=-f2[0];
        ret[2][1]=-f2[1];
        ret[2][2]=-f2[2];
        ret[2][3]=0;
        ret[3][0]=0;
        ret[3][1]=0;
        ret[3][2]=0;
        ret[3][3]=1;
        return ret;
    }
}
class MatMult2{
    public static void multleft(Transform3D original,Transform3D mult){
        float[]a=new float[16];
        mult.get(a);
        float[][]a2=new float[4][4];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                a2[i][j]=a[i*4+j];
            }
        }
        float[]b=new float[16];
        original.get(b);
        float[][]b2=new float[4][4];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                b2[i][j]=b[i*4+j];
            }
        }
        float[][]c2=new float[4][4];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                for(int k=0;k<4;k++){
                    c2[i][j]=c2[i][j]+a2[i][k]*b2[k][j];
                }
            }
        }
        float[]c=new float[16];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                c[i*4+j]=c2[i][j];
            }
        }
        original.set(c);
    }
}
class AWTBehavior extends ViewPlatformAWTBehavior{
    Engine eng;
    int keycode=0;
    Transform3D trans;
    public AWTBehavior(Engine eng){
        super(eng,KEY_LISTENER);
        this.eng=eng;
    }
    public int getKeyCode(){
        return keycode;
    }
    public void initialize(){
        setSchedulingBounds(new BoundingSphere(new Point3d(0,0,0),10000));
        wakeupOn(new WakeupOnAWTEvent(AWTEvent.KEY_EVENT_MASK));
    }
    public void processStimulus(Enumeration enumeration){
        wakeupOn(new WakeupOnAWTEvent(AWTEvent.KEY_EVENT_MASK));
        AWTEvent[]awte=((WakeupOnAWTEvent) enumeration.nextElement()).getAWTEvent();
        for(int i=0;i<awte.length;i++){
            KeyEvent event = (KeyEvent)awte[i];
            int key=event.getKeyCode();
            if(key!=0){
                eng.keycode=key;
            }
        }
//System.out.println("keycode: "+keycode);
    }
    public void integrateTransforms(){
        trans=new Transform3D();
        float[][]mat=Projection.projection(0,0,0,0,0,100,1,0,0);
        float[]mat2=Projection.convert(mat);
        trans.set(mat2);
        setHomeTransform(trans);
    }
    public void processAWTEvents(AWTEvent[]event){
    }
    public Node cloneNode(boolean forceDuplicate){
        return (new AWTBehavior(eng));
    }
}
